﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ScaffoldIt.Configuration;

namespace ScaffoldIt
{
    public partial class FormEditCategory : Form
    {
        public FormEditCategory()
        {
            InitializeComponent();
        }

        public static bool EditCategory(Category category)
        {
            using (var frm = new FormEditCategory())
            {
                frm.Init(category);
                frm.textBoxName.Focus();
                if (frm.ShowDialog() == DialogResult.OK)
                {
                    frm.Read(category);
                    return true;
                }
            }

            return false;
        }

        private void Read(Category category)
        {
            category.Name = textBoxName.Text;
            category.Description = textBoxDescription.Text;
        }

        private void Init(Category category)
        {
            textBoxName.Text = category.Name;
            textBoxDescription.Text = category.Description;
        }

        private void textBoxName_Validating(object sender, CancelEventArgs e)
        {
            if (string.IsNullOrEmpty(textBoxName.Text))
            {
                e.Cancel = true;
                errorProvider1.SetError(textBoxName, "You must provide a name");
            }
        }

        private void btnOk_Click(object sender, EventArgs e)
        {
            if (this.ValidateChildren())
                DialogResult = DialogResult.OK;
        }
    }
}
